<template>
    <div class="lastPage--lastTable">
        <select-wrapper v-slot="slotProps" :options="sort_options" :value="current_sort" :opened="sort_opened" >
            <div class="block-sort box-sortirovka" @click="sort_opened = !sort_opened">
                <div class="headSort">
                    <p class="text-sort">{{ $t('users.table.sort_by') }}</p>
                    <p id="sort" class="text-sortBlue">{{ slotProps.current_label }}</p>
                    <svg class="down" :style="slotProps.arrowStyle">
                        <use xlink:href="/img/sprite.svg#right-arrow-circular-button"/>
                    </svg>
                </div>
                <transition name="slide">
                    <div class="bodySort" v-if="sort_opened">
                        <p class="text-login" v-for="(label, key) in slotProps.options" @click="current_sort = key">{{ label }}</p>
                    </div>
                </transition>
            </div>
        </select-wrapper>
        <div class="box-topTableName wow fadeInUp">
            <div class="box-tableLeft">
                <div class="tableLeft--left">
                    <p class="text-id">{{ $t('users.table.id') }}</p>
                    <p class="text-id">{{ $t('users.table.login') }}</p>
                </div>
                <div class="tableLeft--right">
                    <p class="text-id balans">{{ $t('users.table.balance') }}</p>
                    <p class="text-id register">{{ $t('users.table.created') }}</p>
                    <p class="text-id vxod">{{ $t('users.table.last_login') }}</p>
                    <p class="text-id ip">{{ $t('users.table.last_login_ip') }}</p>
                    <p class="text-id country">{{ $t('users.table.country') }}</p>
                    <p class="text-id status">{{ $t('users.table.role') }}</p>
                    <p class="text-id status2">{{ $t('users.table.online') }}</p>
                </div>
            </div>
            <div class="box-tableRight--edit">
                <p class="text-blue">{{ $t('users.table.edit') }}</p>
            </div>
        </div>
        <user v-for="user in users" :user="user" :key="user.id" @reload="submit"/>
        <paginator
            :current-page="currentPage"
            :last-page="lastPage"
            :per-page="perPage"
            :items-count="total"
            @page-changed="setPage"
        />
    </div>
</template>

<script>
	import {mapGetters} from "vuex";
	import User from "./User";

    export default {
		name: "UsersTable",
		props: {
			query: {
				type: String,
				default: ''
			}
		},
        data(){
            return {
                currentPage: 0,
                lastPage: 0,
                perPage: 0,
                total: 0,
                page: 1,
                current_sort: 'id',
                users: [],
                sort_opened: false,
                sort_options: {
                    'id':               this.$t('users.table.sorts.id'),
                    'login':            this.$t('users.table.sorts.login'),
                    'balance':          this.$t('users.table.sorts.balance'),
                    'created_at':       this.$t('users.table.sorts.created_at'),
                    'last_login_at':    this.$t('users.table.sorts.last_login_at'),
                    'last_login_ip':    this.$t('users.table.sorts.last_login_ip'),
                    'country_code':     this.$t('users.table.sorts.country_code'),
                    'role':             this.$t('users.table.sorts.role'),
                },
            }
        },
        computed: {
            ...mapGetters([
                'axios'
            ])
        },
        watch: {
            current_sort(sort){
                this.submit();
            },
        },
        methods: {
            submit(){
                this.axios
                    .get('users', {
                        params: {
                            sort_by: this.current_sort,
                            page: this.page,
							search: this.query
                        }
                    })
                    .then(resp => resp.data)
                    .then(users => {
                        console.log(users);
                        this.currentPage = users.current_page;
                        this.lastPage = users.last_page;
                        this.perPage = users.per_page;
                        this.total = users.total;
                        this.users = users.data;
                    });
            },
            setPage(page){
                this.page = page;
                this.submit();
            },
        },
        created(){
            this.submit();
        },
        components: {
		    User
        }
	}
</script>

<style scoped>
    .slide-enter-active,
    .slide-leave-active {
        transition: max-height 1s ease;
    }
    .slide-enter,
    .slide-leave-to {
        max-height: 0px;
    }
</style>
